-- 武库器谱
Lua_CardAllShowWindow = class("Lua_CardAllShowWindow", Lua_Window)
function Lua_CardAllShowWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CardAllShowWindow";
	self.skinName = "CardAllShowWindow_skin";
end

function Lua_CardAllShowWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.titleNameLab.text = LanUtil.getValue(128202);

	local arr = DataCenter.cardUtil.cardConfigInfo;
	self.recordsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 720, 460));
	self.recordsList:setListCell(Lua_CardAllShowItem, 215, 182, 4);
	self.recordsList:setLocation(0, -28, 0);
	self.recordsList:setLuaArrayData(arr, false);
end

function Lua_CardAllShowWindow:dispose()
	if self.recordsList ~= nil then
		self.recordsList:dispose()
		self.recordsList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_CardAllShowItem = class("Lua_CardAllShowItem", Lua_ListCell);
function Lua_CardAllShowItem:ctor(p)
	self:superCall("ctor", p, "CardAllShowItem_skin");
end

function Lua_CardAllShowItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_CardAllShowItem:setData(data)
	self.data = data.itemVo;

	self.cardNameLab.text = self.data.name;

	self.itemBg:setAltas("wuku_atlas", "ui_wuku_bg_0"..(self.data.color - 1));

	self.cardIcon:SetDimensions(0, 0);
	self.cardIcon:setUrl(self.data.cardAtlas);
	self.cardIcon:setScale(0.7, 0.7);
end

function Lua_CardAllShowItem:onPlayerSoundClick(go)
	if self.data ~= nil then
		Lua_PackUtil.showItemInfo(self.data, false, nil, false); -- 显示卡牌Tips
	end
end

function Lua_CardAllShowItem:dispose()
	self:superCall("dispose");
end