Lua_CardGroupWindowPlane  = class("Lua_CardGroupWindowPlane", Lua_DisplayObject);
function Lua_CardGroupWindowPlane:ctor(p, data, color)
	self.data = data;
	self.color = color;
	self:superCall("ctor", p);
end

function Lua_CardGroupWindowPlane:buildShowItem()
	self:superCall("buildShowItem");
	
	self.recordsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 805, 258));
	self.recordsList:setListCell(Lua_CardGroupItem, 230, 210, 4);
	self.recordsList:setSubPos(-17, 0);
	self.recordsList:setLocation(130, 68, 0);

	self.textArea = Lua_TextArea.new(self.content, 740, 100);
	self.textArea.insideItem.label.fontSize = 22;
	self.textArea.insideItem.label.spacingY = 3;
	self.textArea.dragContainer.canDrag = false;
	self.textArea:setLocation(-261, -208, 0);

	self:updateGroupPanel()
end

function Lua_CardGroupWindowPlane:updateGroupPanel()
	local _arr = DataCenter.cardUtil:getArrByAllCardGroupSkill(self.data, self.color)
	self.textArea:setText(_arr);

	local arr = DataCenter.cardUtil:getArrByAllCardGroupInfo(self.data, self.color);
	self.recordsList:setLuaArrayData(arr, false);
end

function Lua_CardGroupWindowPlane:dispose()
	if self.recordsList ~= nil then
		self.recordsList:dispose()
		self.recordsList = nil;
	end
	if self.textArea ~= nil then
		self.textArea:dispose()
		self.textArea = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_CardGroupItem = class("Lua_CardGroupItem", Lua_ListCell);
function Lua_CardGroupItem:ctor(p)
	self:superCall("ctor", p, "CardResolveItem_skin");
end

function Lua_CardGroupItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_CardGroupItem:setData(data)
	self.data = data;

	self.show:setEnable(false);
	self.bind:setEnable(false);

	self.card_lvl.text = data.card_level;
	self.card_name.text = data.name;

	self.card_bg:setAltas("wuku_atlas", "ui_wuku_bg_0"..(self.data.color - 1));

	self.card_icon:SetDimensions(0, 0);
	self.card_icon:setUrl(data.cardAtlas);
	self.card_icon:setScale(0.75, 0.75);
end

function Lua_CardGroupItem:onPlayerSoundClick(go)
	if self.data ~= nil then
		Lua_PackUtil.showItemInfo(self.data, false, nil, false); -- 显示卡牌Tips
	end
end

function Lua_CardGroupItem:dispose()
	self:superCall("dispose");
end