-- 武库背包
Lua_CardPackWindow = class("Lua_CardPackWindow", Lua_SecondSizeWindow)
function Lua_CardPackWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CardPackWindow";
	self.skinName = "CardPackWindow_skin";
	self.titleText = LanUtil.getValue(110800);
end

function Lua_CardPackWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.recordsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 1021, 505));
	self.recordsList:setListCell(Lua_CardPackItem, 232, 210, 5);
	self.recordsList:setLocation(-7, -25, 0);

	self:addLuaEvent("PACK_CARD_UPDATE", self, self.onUpdateData)
	self:onUpdateData();
end

function Lua_CardPackWindow:showWin(param)
	self:superCall("showWin", param);

	self.grooveId = param.grooveId;
	self.armory_type = param.armory_type;

	self:onUpdateData();
end

-- 更新背包数据
function Lua_CardPackWindow:onUpdateData()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.CARD_PACK);
	local arr = bagData:getBagAllData();

	-- 排序
	local len = arr:getSize();
	for i = 1, len do
		for j = i + 1, len do
			if not self:sortFun(arr[i], arr[j]) then
				local temp = arr[i]
				arr[i] = arr[j]
				arr[j] = temp
			end
		end
	end

	local result = Array();
	for i = 1, len do
		if arr[i].card_type == self.armory_type then
			result:add({data = arr[i], grooveId = self.grooveId});
		end
	end
	self.recordsList:setLuaArrayData(result, false);
end

function Lua_CardPackWindow:sortFun(a, b)
	if a == nil or b == nil then
	return false;
	end

	if a.color > b.color then
		return true;
	elseif a.color == b.color then
		if a.card_level > b.card_level then
			return true;
		end
	end
	return false;
end

function Lua_CardPackWindow:dispose()
	if self.recordsList ~= nil then
		self.recordsList:dispose()
		self.recordsList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_CardPackItem = class("Lua_CardPackItem", Lua_ListCell);
function Lua_CardPackItem:ctor(p)
    self:superCall("ctor", p, "CardResolveItem_skin");
end

function Lua_CardPackItem:buildShowItem()
    self:superCall("buildShowItem");

    -- self.rune:addClickFuntion(self, self.onIconClick);

	-- self.bg_hide要监听点击事件，名字不要改，给指引功能那边用，不要删，改了的话，要告诉策划那边
	-- self.bg_hide.clickScale = false;
	-- self.bg_hide.alpha = 0.1;
	-- self.bg_hide:setDepth(-2);
	-- self.bg_hide:addClickFuntion(self, self.onPlayerSoundClick);
end

function Lua_CardPackItem:setData(data)
	self.data = data;
	self.vo = data.data;

	self.card_lvl.text = self.vo.card_level;
	self.card_name.text = self.vo.name;
	
	self.card_bg:setAltas("wuku_atlas", "ui_wuku_bg_0"..(self.vo.color - 1));

	self.card_icon:SetDimensions(0, 0);
	self.card_icon:setUrl(self.vo.cardAtlas);
	self.card_icon:setScale(0.75, 0.75);
	
	self.bind:setEnable(self.vo.bind ~= 0);
	self.show:setEnable(false);
end

function Lua_CardPackItem:onIconClick(go)
	if self.vo ~= nil then
		Lua_PackUtil.showItemInfo(self.vo, false);
	end
end

function Lua_CardPackItem:onPlayerSoundClick(go) -- 替换卡牌
	Lua_PackUtil.showItemInfo(self.vo, false, nil, true); -- 显示卡牌Tips
end

function Lua_CardPackItem:dispose()
	self:superCall("dispose");
end