-- 卡牌升级
checkRequire("Lua_CardUpdateItem");
Lua_CardUpdateWindow  = class("Lua_CardUpdateWindow",Lua_Window);
function Lua_CardUpdateWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CardUpdateWindow";
	self.skinName = "cardUpgradeWindow_skin";
end

function Lua_CardUpdateWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isPos = false;

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 400, 64));
	self.dragContainer:setLocation(-6, -79, 0);
	self.prop = Lua_CardUpdateItem.new(self.dragContainer.content);
	self.dragContainer.offsetX = -25;

	self.cardBg.clickScale = false;
	self.cardBg:addClickFuntion(self, self.onCardIconClick);
	self.upgradeBtn:addClickFuntion(self, self.onUpgradeBtnClick);

	self:showCardUpgradeInfo();
	self:addLuaEvent("UPDATE_CARD_INFO", self, self.showCardUpgradeInfo);
end

function Lua_CardUpdateWindow:showCardUpgradeInfo()
	local grooveId = DataCenter.cardData.openGrooveId;
	self.data = DataCenter.cardData:getArrByCardInfo(grooveId);
	self.vo = self.data.cardVo;

	self.fragment = DataCenter.cardData.fragment;
	self.cardLvLab.text = self.vo.card_level;
	
	self.cardNameLab.text = self.vo.name;
	self.cardBg:setAltas("wuku_atlas", "ui_wuku_bg_0"..(self.vo.color - 1));

	self.cardIcon:SetDimensions(0, 0);
	self.cardIcon:setSacle(0.75, 0.75);
	self.cardIcon:setUrl(self.vo.cardAtlas);
	
	self.bind:setEnable(self.data.card_bind ~= 0);

	-- 属性显示
	if self.prop.arr ~= nil then
		for i = 1, self.prop.arr:getSize() do
			self.prop.arr[i]:dispose();
		end
		self.prop.arr:clear();
	end

	self.prop:setParam(self.data.updateProp, self.data.updateAddProp, self.data.isMaxLevel);
	self.dragContainer:addSubContainer(self.prop, false);
	self.dragContainer.canDrag = self.data.updateProp:getSize() ~= 2;

	if self.data.updateProp:getSize() ~= 2 then
		if self.isPos == false then
			self.isPos = true;
			self.dragContainer:updateChildPos();
		end
	end

	if self.data.isMaxLevel ~= true then
		self.cardChipIcon:setEnable(true);
		if tonumber(self.fragment) >= tonumber(self.vo.cost_item_num) then
			str = self.fragment;
		else
			str = "["..Lua_ColorDefine.RED_STR.."]"..self.fragment.."[-]";
		end
		self.updateTxt.text = LanUtil.formateStr(LanUtil.getValue(128205), tostring(str), tostring(self.vo.cost_item_num));
	else
		self.cardChipIcon:setEnable(false);
		self.updateTxt:setLocation(-43, -154);
		self.updateTxt.text = LanUtil.getValue(128216);
	end
	self:updateCardRed();
end

-- 分解红点显示
function Lua_CardUpdateWindow:updateCardRed()
	local isShowResolveRed = self.data:isShowCardUpgradeRed();
	self:showRedDot(isShowResolveRed);
end

function Lua_CardUpdateWindow:showRedDot(val)
	if val then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 71, -186, 0, 0);
			self._redDot.name = "redDot";
			self._redDot:setDepth(7);
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end

function Lua_CardUpdateWindow:onCardIconClick()
	if self.vo ~= nil then
		Lua_PackUtil.showItemInfo(self.vo, false, nil, false);
	end
end

function Lua_CardUpdateWindow:onUpgradeBtnClick()
	if self.data.isMaxLevel ~= true then
		if tonumber(self.fragment) >= tonumber(self.vo.cost_item_num) then
			Lua_ProxyManager.getProxy("Lua_CardProxy"):sUpgradeCard(DataCenter.cardData.openGrooveId);
		else
			OperateAlert.show(LanUtil.getValue(128206));
		end
	else
		OperateAlert.show(LanUtil.getValue(110526));
	end
end

function Lua_CardUpdateWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	if self._redDot ~= nil then
		self._redDot:dispose();
		self._redDot = nil;
	end

	self:superCall("dispose");
end