-- 武库界面
checkRequire("Lua_CardItem");
checkRequire("Lua_CardSkillItem");
checkRequire("Lua_CommonPropItem");
Lua_CardWindow = class("Lua_CardWindow", Lua_FullSizeWindow)
function Lua_CardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CardWindow";
	self.skinName = "CardWindow_skin";
end

function Lua_CardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:setShowTitle("titleName_altas_1", "wuku");

	self.skill1 = Array();
	self.skill2 = Array();

	local poses = {{-462, 144}, {-6, 144}, {-521, -90}, {53, -90}, {-335, -210}, {-133, -210}, {-234, 64}};
	local item;
	self.itemArr = Array();
	for i, v in ipairs(poses) do
		item = Lua_CardItem.new(self.content); -- 左槽
		item:setLocation(v[1], v[2], 0);
		item:setDepth(10);
		item:setCanClick(true);
		item:setCardNnmetype(i); -- 卡牌名字编号
		item:updateLocation(i);
		self.itemArr:add(item);
	end

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.prefix = "";
	self.fightNum.num = 0;
	self.fightNum.numWidth = 13;
	self.fightNum:setDepth(6);
	self.fightNum:setLocation(402, 254, 0);

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 440, 145));
	self.dragContainer:setLocation(386, 100, 0);
	self.prop = Lua_CommonPropItem.new(self.dragContainer.content);

	self.showButton:addClickFuntion(self, self.onAllShowClick);--器谱
	self.groupButton:addClickFuntion(self, self.onGroupButtonClick);--组合
	self.decomposeButton:addClickFuntion(self, self.onResolveClick);--分解
	self.leftwenhao:addClickFuntion(self, self.onHelpClick);--问号

	self:addLuaEvent("UPDATE_CARD_INFO", self, self.openCardPanelInfo) -- 打开面板
	self:addLuaEvent("PACK_CARD_UPDATE", self, self.openCardPanelInfo) -- 打开面板
	Lua_ProxyManager.getProxy("Lua_CardProxy"):sOpenCardPanelInfo();
end

function Lua_CardWindow:openCardPanelInfo()--打开灵纹面板
	self.fightNum.num = DataCenter.cardData.getCardForce;

	-- 属性显示
	if self.prop.arr ~= nil then
		for i = 1,self.prop.arr:getSize() do
			self.prop.arr[i]:dispose();
		end
		self.prop.arr:clear();
	end

	local attProp = DataCenter.cardData.genAttProp
    self.prop:setParam(attProp);
    self.dragContainer:addSubContainer(self.prop, false);
	self.dragContainer.canDrag = attProp:getSize() > 8;

	-- 卡片显示
	local data = DataCenter.cardData.cardHolesInfo;
	for k,v in ipairs(data) do
		if v.cardPart ~= nil then
			self.itemArr[v.cardPart]:setCardtype(v);
		end
	end

	-- 技能显示
	self.skill_data = DataCenter.cardData.cardSkillInfo;
	self.len = self.skill_data:getSize();

	if self.len > 0 then
		self:updateSkillPanel()
	else
		if self.skill1 ~= nil then
			self.skill1:dispose();
			self.skill1:clear();
		end
		if self.skill2 ~= nil then
			self.skill2:dispose();
			self.skill2:clear();
		end
		self.skill_name1:setEnable(false);
		self.skill_name2:setEnable(false);
	end
	self:updateCardResolveRed();
end

function Lua_CardWindow:updateSkillPanel()
	local skill_vo = self.skill_data[1];
	local skill_vo1 = self.skill_data[2];
	if self.skill1 ~= nil then
		self.skill1:dispose();
		self.skill1:clear();
	end

	if self.skill2 ~= nil then
		self.skill2:dispose();
		self.skill2:clear();
	end

	local item;
	for i,v in ipairs(skill_vo.skill) do
		item = Lua_CardSkillItem.new(self.content); -- 技能图标1
		item:setLocation(245 + i * 100, -75, 0);
		item:setCanClick(true);
		item:setScale(0.9, 0.9, 1)
		item:setCardSkillType(v, skill_vo.color);
		self.skill1:add(item);
	end

	self.skill_name1:setEnable(true);
	self.skill_name1.text = skill_vo.name;
	if skill_vo1 ~= nil then
		self.skill_name2:setEnable(true)
		self.skill_name2.text = skill_vo1.name;

		for i,v in ipairs(skill_vo1.skill) do
			item = Lua_CardSkillItem.new(self.content); -- 技能图标2
			item:setLocation(245 + i * 100, -193, 0);
			item:setCanClick(true);
			item:setScale(0.9, 0.9, 1)
			item:setCardSkillType(v,skill_vo1.color);
			self.skill2:add(item);
		end
	else
		if self.skill2 ~= nil then
			self.skill2:dispose();
			self.skill2:clear();
		end
		self.skill_name2.uiwidget.gameObject:SetActive(false);
	end
end

-- 红点更新
function Lua_CardWindow:updateCardResolveRed()
	local isShowResolveRed = DataCenter.cardData:isShowCardResolveRed();
	if isShowResolveRed == true then
		self:showRedResolveDot(true); -- 分解红点显示
	else
		self:showRedResolveDot(false);
	end
end

function Lua_CardWindow:updaLabelPos(prolab, addObj, dis1, label, dis2)
	if (dis1 == nil) then dis1 = 10; end
	if (dis2 == nil) then dis2 = 0; end
	LuaUtil.setObjPos(label, prolab.width + dis2, 0, 0);
	LuaUtil.setObjPos(addObj, label.transform.localPosition.x + label.width + dis1, 1, 0);
end

-- 分解红点显示
function Lua_CardWindow:showRedResolveDot(val)
	if val == true then
		if self._redDotIcon == nil then
			self._redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 594, -280, 0, 0);
			self._redDotIcon:setDepth(7);
			self._redDotIcon.name = "redDot";
			end
		self._redDotIcon:setEnable(true);
	else
		if self._redDotIcon ~= nil then
			self._redDotIcon:setEnable(false);
		end
	end
end

-- 组合
function Lua_CardWindow:onGroupButtonClick()
	Lua_WindowUtil.openWin("Lua_CardGroupWindow");
end

-- 器谱
function Lua_CardWindow:onAllShowClick()
	Lua_WindowUtil.openWin("Lua_CardAllShowWindow");
end

-- 分解
function Lua_CardWindow:onResolveClick()
	Lua_WindowUtil.openWin("Lua_CardResolveWindow");
end

function Lua_CardWindow:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(128214));
end

function Lua_CardWindow:dispose()
	if self.skill1 ~= nil then
		self.skill1:dispose();
		self.skill1 = nil;
	end
	if self.skill2 ~= nil then
		self.skill2:dispose();
		self.skill2 = nil;
	end
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr = nil;
	end
	self:superCall("dispose");
end