-- 武库卡牌item
Lua_CardItem = class("Lua_CardItem", Lua_DisplayObject);
function Lua_CardItem:ctor(p)
	self:superCall("ctor", p, "CardWindowItem_skin");
end

function Lua_CardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.openTxtBg:setEnable(false);
	self.open_lvl:setEnable(false);
	self.openObj:SetActive(false);
end

function Lua_CardItem:setCardNnmetype(val)
	self.cardType = val;
	self.content.name = "Lua_CardItem"..val;
end

function Lua_CardItem:setCardtype(data)
	self.data = data;
	self.vo = data.cardVo;

	if data.open_status == 1 then --已开启
		if data.card_id ~= 0 and data.card_id ~= nil then
			self.bind:setEnable(data.card_bind ~= 0);
			self.card_bg:setAltas("wuku_atlas", "ui_wuku_bg_0"..(self.vo.color - 1));

			self.openObj:SetActive(true);
			self.card_icon:SetDimensions(0, 0);
			self.card_icon:setUrl(self.vo.cardAtlas);
			self.card_lvl.text = self.vo.card_level;
			self.card_name.text = self.vo.name;
		else -- 未穿戴
			self.bind:setEnable(false);
			self.card_bg:setAltas("wuku_atlas", "ui_wuku_bg_05");

			self.openObj:SetActive(false);
		end

		self.openTxtBg:setEnable(false);
		self.open_lvl:setEnable(false);

		self:setCanClick(true);
		self:showRedDot(data.checkCardIconRed);
	else
		self.bind:setEnable(false);
		self.openTxtBg:setEnable(true);
		self.open_lvl:setEnable(true);

		self.card_bg:setAltas("wuku_atlas", "ui_wuku_bg_06");

		self.openObj:SetActive(false);
		self.open_lvl.text = LanUtil.formateStr(LanUtil.getValue(128204), tostring(DataCenter.cardUtil:getOpenCardLvl(data.cardPart)));

		self:setCanClick(false);
		self:showRedDot(false);
	end
	self:showEffect()
end

-- 卡牌背景添加点击方法
function Lua_CardItem:setCanClick(val)
	if val then
		self.card_bg.mouseEnable = true;
		self.card_bg.clickScale = false;
		self.card_bg:addClickFuntion(self, self.onIconClick);
	else
		self.card_bg.mouseEnable = false;
		self.card_bg:removeClickFuntion(self, self.onIconClick);
	end
end

function Lua_CardItem:onIconClick(go)
	DataCenter.cardData.openGrooveId = self.data.cardPart;
	if self.data.card_id ~= 0 and self.data.card_id ~= nil then
		Lua_PackUtil.showItemInfo(self.vo, false, nil, true); -- 显示卡牌Tips
	else
		Lua_WindowUtil.openWin("Lua_CardPackWindow", WinParam.ACTION_OPEN,{grooveId = self.data.cardPart, armory_type = self.data.armory_type});
	end
end

function Lua_CardItem:showRedDot(val)
	if val then
		if self._redDotIcon == nil then
			self._redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 35, 21, 0, 0);
			if self.data.cardPart == 7 then
				self._redDotIcon:setLocation(95, 128);
			else
				self._redDotIcon:setLocation(80, 101);
			end
			self._redDotIcon:setDepth(25);
			self._redDotIcon.name = "redDotIcon1";
		end
		self._redDotIcon:setEnable(true);
	else
		if self._redDotIcon ~= nil then
			self._redDotIcon:setEnable(false);
		end
	end
end

function Lua_CardItem:showEffect()
	if self.data.card_id ~= 0 then
		if self.vo.color == 4 then
			if self.effect == nil then
				self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_biankuang_orange", "gui_biankuang_orange", -1, 5);
			end
			self.effect:SetRenderQueue(self.card_bg, 3, 2,false);

			if self.data.armory_type == 1 then -- 位置类型 1普通 2核心
				self.effect:setSacle(1, 1, 1);
			else
				self.effect:setSacle(1.25, 1.28, 1);
			end
		else
			if self.effect ~= nil then
				self.effect:dispose();
				self.effect = nil;
			end
		end

		if self.vo.color == 5 then
			if self.effect1 == nil then
				self.effect1 = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_biankuang_red", "gui_biankuang_red", -1, 5);
			end
			self.effect1:SetRenderQueue(self.card_bg, 3, 2, false);

			if self.data.armory_type == 1 then -- 位置类型 1普通 2核心
				self.effect1:setSacle(0.77, 0.74, 1);
			else
				self.effect1:setSacle(0.95, 0.95, 1);
			end
		else
			if self.effect1 ~= nil then
				self.effect1:dispose();
				self.effect1 = nil;
			end
		end
	else
		if self.effect ~= nil then
			self.effect:dispose();
			self.effect = nil;
		end

		if self.effect1 ~= nil then
			self.effect1:dispose();
			self.effect1 = nil;
		end
	end
end

function Lua_CardItem:updateLocation(val)
	if val == 7 then
		self.card_lvl.fontSize = 26;
		self.card_lvl:setLocation(-87, 117);
		self.card_name.fontSize = 26;
		self.card_name:setLocation(-87, 37);
		self.card_icon:setScale(1, 1, 1);
		self.card_bg:SetDimensions(209, 280);
		self.bind:setLocation(-75, -104)
	else
		self.card_lvl.fontSize = 22;
		self.card_lvl:setLocation(-70, 93);
		self.card_name.fontSize = 22;
		self.card_name:setLocation(-70, 26);
		self.card_icon:setScale(0.75, 0.75, 1);
		self.openTxtBg:SetDimensions(155, 35);
		self.card_bg:SetDimensions(172, 217);
		self.bind:setLocation(-60, -76)
	end
end

function Lua_CardItem:setDepth(val)
	self:superCall("setDepth", val);

	self.card_bg:setDepth(val);
	self.openTxtBg:setDepth(val + 1);
	self.open_lvl:setDepth(val + 2);
	self.card_icon:setDepth(val + 1);
	self.card_lvl:setDepth(val + 2);
	self.card_name:setDepth(val + 2);
	self.bind:setDepth(val + 2);
end