-- 武库卡牌技能item
Lua_CardSkillItem = class("Lua_CardSkillItem", Lua_DisplayObject);
function Lua_CardSkillItem:ctor(p)
	self:superCall("ctor", p, "CardSkillItem_skin");
end

function Lua_CardSkillItem:buildShowItem()
	self:superCall("buildShowItem");
	
	self.iocn.clickScale = false;
end

function Lua_CardSkillItem:setCardSkillType(id,color)
	self.id = id;
	self.color = color;
	self.iocn:setAltas("skillIcon_atlas_1", tostring(id));
end

function Lua_CardSkillItem:setCanClick(val) -- 卡牌背景添加点击方法
	if val == true then
		self.iocn.mouseEnable = true;
		self.iocn:addClickFuntion(self, self.onIconClick);
	else
		self.iocn.mouseEnable = false;
		self.iocn:removeClickFuntion(self, self.onIconClick);
	end
end

function Lua_CardSkillItem:onIconClick(go)
	local skillVo  = Lua_SkillVo.new(self.id);
	local detail = skillVo:getCurPercent(self.color);

	local data = {};
	data.name = skillVo.name;
	data.skillIcon=skillVo.skillIcon;
	data.limittype = LanUtil.getValue(110601);
	if tonumber(skillVo.cool) == 0 then
		data.cool = LanUtil.getValue(120011); 
	else
		data.cool = LanUtil.formateStr(LanUtil.getValue(110612), tostring(skillVo.cool));
	end
	data.desc = LanUtil.formateStr(skillVo.des, tostring(math.abs(detail)));
	data.is_card = true;
	Lua_WindowUtil.openWin("Lua_AwakeSkillTipsWindow", nil, data)
end

function Lua_CardSkillItem:dispose()
	self:superCall("dispose");
end